﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace Diplomová_práce
{
  public partial class MainWindow : Form
  {
    private BackgroundWorker bw;
    private ProgressWindow progress;
    private StringBuilder text, puvodniText;
    private int result, percent, saved;
    private string msgtitle, title, url, filename, charset;
    public Dictionary<string, string> znakovaSada;
    public Dictionary<string, int> cetnost, cetnostVlastni;
    // globální proměnné pro nastavení programu
    public int cfg_ok, cfg_title, cfg_zalamovani, cfg_nekorektniHTML, cfg_vyrazCS;
    public string cfg_znakovaSada;
    public Color cfg_barvaGrafu;
    public int cfg_cetnost, cfg_cetnostRBtn, cfg_cetnostLimit, cfg_cetnostDelka;

    public MainWindow()
    {
      InitializeComponent();
      bw = new BackgroundWorker();
      bw.WorkerSupportsCancellation = true;
      bw.WorkerReportsProgress = true;
      bw.DoWork += new DoWorkEventHandler(bw_DoWork);
      bw.ProgressChanged += new ProgressChangedEventHandler(bw_ProgressChanged);
      bw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(bw_RunWorkerCompleted);
      progress = new ProgressWindow(bw);
      text = new StringBuilder();
      puvodniText = new StringBuilder();
      result = 0;
      msgtitle = this.Text;
      title = "";
      percent = 0;
      saved = 0;
      url = "";
      filename = "";
      charset = "utf-8";
      cetnost = new Dictionary<string, int>();
      cetnostVlastni = new Dictionary<string, int>();
      // globální proměnné pro nastavení programu
      cfg_ok = 0;
      cfg_title = 1;
      cfg_zalamovani = 1;
      cfg_nekorektniHTML = 0;
      cfg_vyrazCS = 0;
      cfg_znakovaSada = "auto";
      cfg_barvaGrafu = Color.Orange;
      cfg_cetnost = 1;
      cfg_cetnostRBtn = 0;
      cfg_cetnostLimit = 10;
      cfg_cetnostDelka = 3;
      // načtení výchozího nastavení programu
      useSettings();

      // naplnění slovníku znakovaSada hodnotami
      znakovaSada = new Dictionary<string, string>()
      {
	      {"auto", "Automatická detekce"},
        {"utf-8", "Unicode (UTF-8)"},
        {"iso-8859-2", "Central European (ISO-8859-2)"},
        {"windows-1250", "Central European (Windows-1250)"},
        {"-", "-"},
        {"IBM864", "Arabic (864)"},
        {"ASMO-708", "Arabic (ASMO 708)"},
        {"DOS-720", "Arabic (DOS)"},
        {"iso-8859-6", "Arabic (ISO)"},
        {"x-mac-arabic", "Arabic (Mac)"},
        {"windows-1256", "Arabic (Windows)"},
        {"ibm775", "Baltic (DOS)"},
        {"iso-8859-4", "Baltic (ISO)"},
        {"windows-1257", "Baltic (Windows)"},
        {"ibm852", "Central European (DOS)"},
        {"x-mac-ce", "Central European (Mac)"},
        {"x-mac-croatian", "Croatian (Mac)"},
        {"cp866", "Cyrillic (DOS)"},
        {"iso-8859-5", "Cyrillic (ISO)"},
        {"koi8-r", "Cyrillic (KOI8-R)"},
        {"koi8-u", "Cyrillic (KOI8-U)"},
        {"x-mac-cyrillic", "Cyrillic (Mac)"},
        {"windows-1251", "Cyrillic (Windows)"},
        {"iso-8859-13", "Estonian (ISO)"},
        {"x-Europa", "Europa"},
        {"IBM863", "French Canadian (DOS)"},
        {"x-IA5-German", "German (IA5)"},
        {"ibm737", "Greek (DOS)"},
        {"iso-8859-7", "Greek (ISO)"},
        {"x-mac-greek", "Greek (Mac)"},
        {"windows-1253", "Greek (Windows)"},
        {"ibm869", "Greek, Modern (DOS)"},
        {"DOS-862", "Hebrew (DOS)"},
        {"iso-8859-8-i", "Hebrew (ISO-Logical)"},
        {"iso-8859-8", "Hebrew (ISO-Visual)"},
        {"x-mac-hebrew", "Hebrew (Mac)"},
        {"windows-1255", "Hebrew (Windows)"},
        {"EUC-CN", "Chinese Simplified (EUC)"},
        {"GB18030", "Chinese Simplified (GB18030)"},
        {"gb2312", "Chinese Simplified (GB2312)"},
        {"x-cp20936", "Chinese Simplified (GB2312-80)"},
        {"hz-gb-2312", "Chinese Simplified (HZ)"},
        {"x-cp50227", "Chinese Simplified (ISO-2022)"},
        {"x-mac-chinesesimp", "Chinese Simplified (Mac)"},
        {"big5", "Chinese Traditional (Big5)"},
        {"x-Chinese-CNS", "Chinese Traditional (CNS)"},
        {"x-Chinese-Eten", "Chinese Traditional (Eten)"},
        {"x-mac-chinesetrad", "Chinese Traditional (Mac)"},
        {"IBM420", "IBM EBCDIC (Arabic)"},
        {"IBM880", "IBM EBCDIC (Cyrillic Russian)"},
        {"cp1025", "IBM EBCDIC (Cyrillic Serbian-Bulgarian)"},
        {"IBM277", "IBM EBCDIC (Denmark-Norway)"},
        {"IBM01142", "IBM EBCDIC (Denmark-Norway-Euro)"},
        {"IBM278", "IBM EBCDIC (Finland-Sweden)"},
        {"IBM01143", "IBM EBCDIC (Finland-Sweden-Euro)"},
        {"IBM297", "IBM EBCDIC (France)"},
        {"IBM01147", "IBM EBCDIC (France-Euro)"},
        {"IBM273", "IBM EBCDIC (Germany)"},
        {"IBM01141", "IBM EBCDIC (Germany-Euro)"},
        {"cp875", "IBM EBCDIC (Greek Modern)"},
        {"IBM423", "IBM EBCDIC (Greek)"},
        {"IBM424", "IBM EBCDIC (Hebrew)"},
        {"IBM871", "IBM EBCDIC (Icelandic)"},
        {"IBM01149", "IBM EBCDIC (Icelandic-Euro)"},
        {"IBM500", "IBM EBCDIC (International)"},
        {"IBM01148", "IBM EBCDIC (International-Euro)"},
        {"IBM280", "IBM EBCDIC (Italy)"},
        {"IBM01144", "IBM EBCDIC (Italy-Euro)"},
        {"IBM290", "IBM EBCDIC (Japanese katakana)"},
        {"x-EBCDIC-KoreanExtended", "IBM EBCDIC (Korean Extended)"},
        {"IBM870", "IBM EBCDIC (Multilingual Latin-2)"},
        {"IBM284", "IBM EBCDIC (Spain)"},
        {"IBM01145", "IBM EBCDIC (Spain-Euro)"},
        {"IBM-Thai", "IBM EBCDIC (Thai)"},
        {"IBM1026", "IBM EBCDIC (Turkish Latin-5)"},
        {"IBM905", "IBM EBCDIC (Turkish)"},
        {"IBM285", "IBM EBCDIC (UK)"},
        {"IBM01146", "IBM EBCDIC (UK-Euro)"},
        {"IBM037", "IBM EBCDIC (US-Canada)"},
        {"IBM01140", "IBM EBCDIC (US-Canada-Euro)"},
        {"IBM01047", "IBM Latin-1"},
        {"IBM00924", "IBM Latin-1"},
        {"x-cp20003", "IBM5550 Taiwan"},
        {"ibm861", "Icelandic (DOS)"},
        {"x-mac-icelandic", "Icelandic (Mac)"},
        {"x-iscii-as", "ISCII Assamese"},
        {"x-iscii-be", "ISCII Bengali"},
        {"x-iscii-de", "ISCII Devanagari"},
        {"x-iscii-gu", "ISCII Gujarati"},
        {"x-iscii-ka", "ISCII Kannada"},
        {"x-iscii-ma", "ISCII Malayalam"},
        {"x-iscii-or", "ISCII Oriya"},
        {"x-iscii-pa", "ISCII Punjabi"},
        {"x-iscii-ta", "ISCII Tamil"},
        {"x-iscii-te", "ISCII Telugu"},
        {"x-cp20269", "ISO-6937"},
        {"euc-jp", "Japanese (EUC)"},
        {"iso-2022-jp", "Japanese (JIS)"},
        {"csISO2022JP", "Japanese (JIS-Allow 1 byte Kana)"},
        {"x-mac-japanese", "Japanese (Mac)"},
        {"shift_jis", "Japanese (Shift-JIS)"},
        {"ks_c_5601-1987", "Korean"},
        {"euc-kr", "Korean (EUC)"},
        {"iso-2022-kr", "Korean (ISO)"},
        {"Johab", "Korean (Johab)"},
        {"x-mac-korean", "Korean (Mac)"},
        {"x-cp20949", "Korean Wansung"},
        {"iso-8859-3", "Latin 3 (ISO)"},
        {"iso-8859-15", "Latin 9 (ISO)"},
        {"IBM865", "Nordic (DOS)"},
        {"x-IA5-Norwegian", "Norwegian (IA5)"},
        {"IBM855", "OEM Cyrillic"},
        {"IBM00858", "OEM Multilingual Latin I"},
        {"IBM437", "OEM United States"},
        {"IBM860", "Portuguese (DOS)"},
        {"x-mac-romanian", "Romanian (Mac)"},
        {"x-IA5-Swedish", "Swedish (IA5)"},
        {"x-cp20261", "T.61"},
        {"x-cp20001", "TCA Taiwan"},
        {"x-cp20004", "TeleText Taiwan"},
        {"x-mac-thai", "Thai (Mac)"},
        {"windows-874", "Thai (Windows)"},
        {"ibm857", "Turkish (DOS)"},
        {"iso-8859-9", "Turkish (ISO)"},
        {"x-mac-turkish", "Turkish (Mac)"},
        {"windows-1254", "Turkish (Windows)"},
        {"x-mac-ukrainian", "Ukrainian (Mac)"},
        {"unicodeFFFE", "Unicode (UTF-16 Big-Endian)"},
        {"utf-16", "Unicode (UTF-16)"},
        {"utf-32BE", "Unicode (UTF-32 Big-Endian)"},
        {"utf-32", "Unicode (UTF-32)"},
        {"utf-7", "Unicode (UTF-7)"},
        {"us-ascii", "US-ASCII"},
        {"windows-1258", "Vietnamese (Windows)"},
        {"x-cp20005", "Wang Taiwan"},
        {"ibm850", "Western European (DOS)"},
        {"x-IA5", "Western European (IA5)"},
        {"iso-8859-1", "Western European (ISO-8859-1)"},
        {"macintosh", "Western European (Mac)"},
        {"Windows-1252", "Western European (Windows-1252)"}
      };
    }

    private void Form1_Load(object sender, EventArgs e)
    {
    }


    #region menu
    // ----------------------------------------------------------------------------------------- //
    //  MENU
    // ----------------------------------------------------------------------------------------- //

    /// <summary>
    /// nový
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuSouborNovy_Click(object sender, EventArgs e)
    {
      if (richTextBoxVystup.Text != "")
      {
        DialogResult result = MessageBox.Show("Práce není uložena, opravdu chcete začít novou práci?", msgtitle, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
        if (result == DialogResult.No)
        {
          return;
        }
      }
      menuNew();
    }

    /// <summary>
    /// otevřít
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuSouborOtevrit_Click(object sender, EventArgs e)
    {
      openFromFile();
    }

    /// <summary>
    /// uložit
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuSouborUlozit_Click_1(object sender, EventArgs e)
    {
      if (saved == 1)
      {
        richTextBoxVystup.SaveFile(filename, RichTextBoxStreamType.PlainText);
      }
      else
      {
        saveToFile();
      }
    }

    /// <summary>
    /// uložit jako
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuSouborUlozit_Click(object sender, EventArgs e)
    {
      saveToFile();
    }

    /// <summary>
    /// konec
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuSouborKonec_Click(object sender, EventArgs e)
    {
      this.Close();
    }

    /// <summary>
    /// ukončení programu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void MainWindow_FormClosing(object sender, FormClosingEventArgs e)
    {
      if ((saved == 0) && (richTextBoxVystup.Text != ""))
      {
        DialogResult result = MessageBox.Show("Práce není uložena! Chcete ji před ukončením uložit?", msgtitle, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
        if (result == DialogResult.Yes)
        {
          saveToFile();
        }
        else if (result == DialogResult.Cancel)
        {
          e.Cancel = true;
        }
      }
    }

    /// <summary>
    /// zobrazení četnosti slov a výrazů
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuNastrojeCetnost_Click(object sender, EventArgs e)
    {
      showCetnost();
    }

    /// <summary>
    /// otevření okna Nastavení
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuNastrojeNastaveni_Click(object sender, EventArgs e)
    {
      SettingsWindow oknoNastaveni = new SettingsWindow(this);
      oknoNastaveni.ShowDialog();
      if (cfg_ok == 1)
      {
        useSettings();
        cfg_ok = 0;
      }
    }

    /// <summary>
    /// otevření okna O programu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void mainMenuNapovedaOprogramu_Click(object sender, EventArgs e)
    {
      AboutWindow oknoOprogramu = new AboutWindow();
      oknoOprogramu.ShowDialog();
    }
    #endregion


    #region popisky
    // ----------------------------------------------------------------------------------------- //
    //  ZOBRAZENÍ/SKRYTÍ POPISKŮ NA STAVOVÉM ŘÁDKU
    // ----------------------------------------------------------------------------------------- //

    // zobrazení popisku Soubor na stavové liště
    private void mainMenuSoubor_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Menu Soubor";
    }

    // zrušení popisku Soubor na stavové liště
    private void mainMenuSoubor_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Soubor - Nový na stavové liště
    private void mainMenuSouborNovy_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Nový dokument";
    }

    // zrušení popisku Soubor - Nový na stavové liště
    private void mainMenuSouborNovy_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Soubor - Otevřít na stavové liště
    private void mainMenuSouborOtevrit_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Otevřít soubor";
    }

    // zrušení popisku Soubor - Otevřít na stavové liště
    private void mainMenuSouborOtevrit_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Soubor - Uložit na stavové liště
    private void mainMenuSouborUlozit_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Uložit text do souboru";
    }

    // zrušení popisku Soubor - Uložit na stavové liště
    private void mainMenuSouborUlozit_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Soubor - Uložit jako na stavové liště
    private void mainMenuSouborUlozitJako_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Uložit text do souboru jako";
    }

    // zrušení popisku Soubor - Uložit jako na stavové liště
    private void mainMenuSouborUlozitJako_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Soubor - Konec na stavové liště
    private void mainMenuSouborKonec_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Konec programu";
    }

    // zrušení popisku Soubor - Konec na stavové liště
    private void mainMenuSouborKonec_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Nástroje na stavové liště
    private void mainMenuNastroje_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Menu Nástroje";
    }

    // zrušení popisku Nástroje na stavové liště
    private void mainMenuNastroje_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Nástroje - Četnost slov na stavové liště
    private void mainMenuNastrojeCetnost_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Četnost slov a výrazů";
    }

    // zrušení popisku Nástroje - Četnost slov na stavové liště
    private void mainMenuNastrojeCetnost_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Nástroje - Nastavení na stavové liště
    private void mainMenuNastrojeNastaveni_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Nastavení programu";
    }

    // zrušení popisku Nástroje - Nastavení na stavové liště
    private void mainMenuNastrojeNastaveni_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Nápověda na stavové liště
    private void mainMenuNapoveda_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Menu Nápověda";
    }

    // zrušení popisku Nápověda na stavové liště
    private void mainMenuNapoveda_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku Nápověda - O programu na stavové liště
    private void mainMenuNapovedaOprogramu_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "O programu";
    }

    // zrušení popisku Nápověda - O programu na stavové liště
    private void mainMenuNapovedaOprogramu_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku radiobuttonu Z internetu na stavové liště
    private void radioButtonZInternetu_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získání dat z internetové adresy";
    }

    // zrušení popisku radiobuttonu Z internetu na stavové liště
    private void radioButtonZInternetu_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku radiobuttonu Ze souboru na stavové liště
    private void radioButtonZeSouboru_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat data ze souboru";
    }

    // zrušení popisku radiobuttonu Ze souboru na stavové liště
    private void radioButtonZeSouboru_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku tlačítka Otevřít na stavové liště
    private void buttonOtevrit_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Otevřít soubor z disku";
    }

    // zrušení popisku tlačítka Otevřít na stavové liště
    private void buttonOtevrit_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku tlačítka Start na stavové liště
    private void buttonStart_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Start programu";
    }

    // zrušení popisku tlačítka Start na stavové liště
    private void buttonStart_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku tlačítka Četnost slov na stavové liště
    private void buttonCetnost_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Četnost slov a výrazů";
    }

    // zrušení popisku tlačítka Četnost slov na stavové liště
    private void buttonCetnost_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku tlačítka Získat na stavové liště
    private void buttonFiltrovat_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace dle zadaného výrazu";
    }

    // zrušení popisku tlačítka Získat na stavové liště
    private void buttonFiltrovat_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku tlačítka Zrušit na stavové liště
    private void buttonZrusitFiltr_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Zobrazit původní získaný text ze vstupu (zrušit získané informace)";
    }

    // zrušení popisku tlačítka Zrušit na stavové liště
    private void buttonZrusitFiltr_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu P na stavové liště
    private void checkBoxP_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z odstavců - mezi HTML tagy <p> a </p>";
    }

    // zrušení popisku checkboxu P na stavové liště
    private void checkBoxP_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu DIV na stavové liště
    private void checkBoxDiv_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z blokových prvků DIV - mezi HTML tagy <div> a </div>";
    }

    // zrušení popisku checkboxu DIV na stavové liště
    private void checkBoxDiv_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu SPAN na stavové liště
    private void checkBoxSpan_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z řádkových prvků SPAN - mezi HTML tagy <span> a </span>";
    }

    // zrušení popisku checkboxu SPAN na stavové liště
    private void checkBoxSpan_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu H1-6 na stavové liště
    private void checkBoxH_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z nadpisů - mezi HTML tagy <h1> až <h6> a </h1> až </h6>";
    }

    // zrušení popisku checkboxu H1-6 na stavové liště
    private void checkBoxH_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu FORM na stavové liště
    private void checkBoxForm_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z formulářů - mezi HTML tagy <form> a </form>";
    }

    // zrušení popisku checkboxu FORM na stavové liště
    private void checkBoxForm_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu TABLE na stavové liště
    private void checkBoxTable_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z tabulek - mezi HTML tagy <table> a </table>";
    }

    // zrušení popisku checkboxu TABLE na stavové liště
    private void checkBoxTable_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu A na stavové liště
    private void checkBoxA_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z odkazů - mezi HTML tagy <a> a </a>";
    }

    // zrušení popisku checkboxu A na stavové liště
    private void checkBoxA_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu OL na stavové liště
    private void checkBoxOl_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z číslovaných seznamů - mezi HTML tagy <ol> a </ol>";
    }

    // zrušení popisku checkboxu OL na stavové liště
    private void checkBoxOl_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }

    // zobrazení popisku checkboxu UL na stavové liště
    private void checkBoxUl_MouseEnter(object sender, EventArgs e)
    {
      statusBarText.Text = "Získat požadované informace z odrážkových seznamů - mezi HTML tagy <ul> a </ul>";
    }

    // zrušení popisku checkboxu UL na stavové liště
    private void checkBoxUl_MouseLeave(object sender, EventArgs e)
    {
      statusBarText.Text = "";
    }
    #endregion


    #region tlacitka
    // ----------------------------------------------------------------------------------------- //
    //  TLAČÍTKA
    // ----------------------------------------------------------------------------------------- //

    /// <summary>
    /// stisknutí tlačítka Start
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonStart_Click(object sender, EventArgs e)
    {
      if (bw.IsBusy != true)
      {
        if (textBoxUmisteni.Text != "")
        {
          textBoxUmisteni.Text = textBoxUmisteni.Text.Trim();
          result = 0;
          text.Clear();
          puvodniText.Clear();
          textBoxTitulek.Clear();
          richTextBoxVystup.Clear();
          textBoxVyraz.Clear();
          setComponents(false);
          cetnost.Clear();
          foreach (String item in cetnostVlastni.Keys.ToList())
          {
            cetnostVlastni[item] = 0;
          }
          bw.RunWorkerAsync();
          progress.progressBarStav.Value = 0;
          progress.labelStav.Text = "0%";
          progress.ShowDialog();
        }
        else
        {
          if (cfg_cetnostRBtn == 0)
          {
            MessageBox.Show("Zadejte URL adresu pro zpracování!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
          }
          else
          {
            MessageBox.Show("Zadejte cestu k souboru pro zpracování!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
          }
        }
      }
    }

    /// <summary>
    /// stisknutí klávesy Enter na textboxu pro zadání umístění
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void textBoxUmisteni_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Return)
      {
        buttonStart_Click(sender, e);
      }
    }

    /// <summary>
    /// stisknutí tlačítka Četnost slov
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonCetnost_Click(object sender, EventArgs e)
    {
      showCetnost();
    }

    /// <summary>
    /// stisknutí tlačítka Otevřít
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonOtevrit_Click(object sender, EventArgs e)
    {
      openFromFile();
    }

    /// <summary>
    /// výběr volby ze souboru
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void radioButtonZeSouboru_CheckedChanged(object sender, EventArgs e)
    {
      labelAdresa.Text = (radioButtonZeSouboru.Checked == true) ? "Zadejte cestu k souboru v počítači:" : "Zadejte URL adresu:";
      textBoxUmisteni.Text = "";
      textBoxUmisteni.Focus();
    }

    /// <summary>
    /// stisknutí tlačítka Získat
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonFiltrovat_Click(object sender, EventArgs e)
    {
      if (textBoxVyraz.Text.Length > 0)
      {
        getInformation();
      }
      else
      {
        MessageBox.Show("Zadejte výraz pro získání požadovaných informací!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      }
    }

    /// <summary>
    /// stisknutí tlačítka Zrušit
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonZrusitFiltr_Click(object sender, EventArgs e)
    {
      richTextBoxVystup.Text = text.ToString().Trim();
    }

    /// <summary>
    /// nastavení komponent (enabled/disabled)
    /// </summary>
    /// <param name="value"></param>
    private void setComponents(bool value)
    {
      checkBoxP.Enabled = value;
      checkBoxDiv.Enabled = value;
      checkBoxSpan.Enabled = value;
      checkBoxH.Enabled = value;
      checkBoxForm.Enabled = value;
      checkBoxTable.Enabled = value;
      checkBoxA.Enabled = value;
      checkBoxOl.Enabled = value;
      checkBoxUl.Enabled = value;
      textBoxVyraz.Enabled = value;
      buttonZiskat.Enabled = value;
      buttonZrusit.Enabled = value;
      if (cfg_cetnost == 1)
      {
        buttonCetnost.Enabled = value;
        mainMenuNastrojeCetnost.Enabled = value;
      }
      else
      {
        buttonCetnost.Enabled = false;
        mainMenuNastrojeCetnost.Enabled = false;
      }
    }
    #endregion


    #region nastaveni
    // ----------------------------------------------------------------------------------------- //
    //  NASTAVENÍ PROGRAMU
    // ----------------------------------------------------------------------------------------- //

    /// <summary>
    /// použití nastavení programu
    /// </summary>
    private void useSettings()
    {
      if (cfg_title == 0)
      {
        labelTitulek.Visible = false;
        textBoxTitulek.Visible = false;
        richTextBoxVystup.Location = new Point(10, 20);
        richTextBoxVystup.Height = groupBoxVystup.Height - 30;
      }
      if (cfg_title == 1)
      {
        labelTitulek.Visible = true;
        textBoxTitulek.Visible = true;
        richTextBoxVystup.Location = new Point(10, 50);
        richTextBoxVystup.Height = groupBoxVystup.Height - 60;
      }
      richTextBoxVystup.WordWrap = (cfg_zalamovani == 1) ? true : false;
      //buttonCetnost.Enabled = (cfg_cetnost == 1) ? true : false;
      //mainMenuNastrojeCetnost.Enabled = (cfg_cetnost == 1) ? true : false;
    }
    #endregion


    #region metody
    // ----------------------------------------------------------------------------------------- //
    //  METODY
    // ----------------------------------------------------------------------------------------- //

    /// <summary>
    /// výpis chybové zprávy
    /// </summary>
    /// <param name="e"></param>
    private void showError(Exception e)
    {
      MessageBox.Show(e.Message, msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      bw.CancelAsync();
    }

    /// <summary>
    /// nový soubor
    /// </summary>
    private void menuNew()
    {
      textBoxUmisteni.Clear();
      textBoxTitulek.Clear();
      richTextBoxVystup.Clear();
      setComponents(false);
      checkBoxP.Checked = true;
      checkBoxDiv.Checked = true;
      checkBoxSpan.Checked = true;
      checkBoxH.Checked = false;
      checkBoxForm.Checked = false;
      checkBoxTable.Checked = false;
      checkBoxA.Checked = false;
      checkBoxOl.Checked = false;
      checkBoxUl.Checked = false;
      textBoxVyraz.Clear();
      cetnost.Clear();
      foreach (String item in cetnostVlastni.Keys.ToList())
      {
        cetnostVlastni[item] = 0;
      }
      percent = 0;
      text.Clear();
      saved = 0;
      url = "";
      filename = "";
      textBoxUmisteni.Focus();
    }

    /// <summary>
    /// otevření a načtení souboru
    /// </summary>
    private void openFromFile()
    {
      OpenFileDialog openFileDialog = new OpenFileDialog();
      openFileDialog.DefaultExt = "*.htm*";
      openFileDialog.Filter = "HTML soubor (*.htm/*.html)|*.htm*";
      if (openFileDialog.ShowDialog() == DialogResult.OK)
      {
        radioButtonZeSouboru.Checked = true;
        textBoxUmisteni.Text = Path.GetFullPath(openFileDialog.FileName);
      }
    }

    /// <summary>
    /// uložení výsledku do souboru
    /// </summary>
    private void saveToFile()
    {
      SaveFileDialog saveFileDialog = new SaveFileDialog();
      saveFileDialog.DefaultExt = "*.txt";
      saveFileDialog.Filter = "Textový soubor (*.txt)|*.txt";
      if (saveFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK && saveFileDialog.FileName.Length > 0)
      {
        try
        {
          richTextBoxVystup.SaveFile(saveFileDialog.FileName, RichTextBoxStreamType.PlainText);
        }
        catch (Exception ex)
        {
          showError(ex);
        }
        saved = 1;
        filename = saveFileDialog.FileName;
      }
    }

    /// <summary>
    /// načtení vstupu do proměnné
    /// </summary>
    /// <param name="worker"></param>
    /// <param name="e"></param>
    private void loadPage(BackgroundWorker worker, DoWorkEventArgs e)
    {
      try
      {
        url = textBoxUmisteni.Text.Trim();
        if (radioButtonZInternetu.Checked == true)
        {
          if (!(url.StartsWith("http://") || url.StartsWith("https://")))
          {
            url = "http://" + url;
          }
          if ((url.IndexOf(" ") == -1) && (Regex.IsMatch(url, @"(http(s)?://)?([\w-]+\.)+[\w-]+(/[\w- ;,./?%&=]*)?")))
          {
            if (cfg_znakovaSada == "auto")
            {
              HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
              HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
              StreamReader str = new StreamReader(resp.GetResponseStream());
              getCharset(str.ReadToEnd());
              str.Close();
            }
            else
            {
              charset = cfg_znakovaSada;
            }
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            StreamReader sr = new StreamReader(response.GetResponseStream(), Encoding.GetEncoding(charset));
            text.Append(sr.ReadToEnd());
            sr.Close();
            worker.ReportProgress(percent + 25);
          }
          else
          {
            MessageBox.Show("Zadaná adresa není ve správném formátu!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Information);
            bw.CancelAsync();
          }
        }
        else
        {
          if (File.Exists(url))
          {
            StreamReader sr = new StreamReader(Path.GetFullPath(url));
            text.Clear();
            text.Append(sr.ReadToEnd());
            sr.Close();
          }
          else
          {
            MessageBox.Show("Zadaný soubor neexistuje!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Information);
            bw.CancelAsync();
          }
        }
      }
      catch (Exception ex)
      {
        showError(ex);
      }
    }

    /// <summary>
    /// získání kódování z HTML
    /// </summary>
    private void getCharset(string data)
    {
      Match m = Regex.Match(data, @"<meta (.|\n)*?>", RegexOptions.IgnoreCase);
      while (m.Success)
      {
        if (m.Value.ToLower().Contains("charset"))
        {
          int start, end;
          start = m.Value.IndexOf("charset=");
          end = m.Value.IndexOf("\"", start);
          charset = m.Value.Substring(start, end - start);
          charset = charset.Replace("charset=", String.Empty);
          break;
        }
        else
        {
          charset = "utf-8";
        }
        m = m.NextMatch();
      }
    }

    /// <summary>
    /// získání titulku
    /// </summary>
    /// <param name="worker"></param>
    private void getTitle(BackgroundWorker worker)
    {
      title = "";
      title = Regex.Match(text.ToString(), @"<title>(.|\n)*?</title>", RegexOptions.IgnoreCase).ToString();
      title = Regex.Replace(title, @"(<title>|</title>)", String.Empty, RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 5);
    }

    /// <summary>
    /// odebrání všeho kromě obsahu stránky
    /// </summary>
    /// <param name="worker"></param>
    private void getBody(BackgroundWorker worker)
    {
      if (Regex.IsMatch(text.ToString(), @"<body(.|\n)*</body>", RegexOptions.IgnoreCase))
      {
        text = new StringBuilder(Regex.Match(text.ToString(), @"<body(.|\n)*</body>", RegexOptions.IgnoreCase).ToString());
      }
      else if (cfg_nekorektniHTML == 0)
      {
        text.Clear();
      }
      worker.ReportProgress(percent + 10);
    }

    /// <summary>
    /// příprava textu pro další úpravy
    /// </summary>
    /// <param name="worker"></param>
    /// <param name="tag"></param>
    private void removeTags(BackgroundWorker worker)
    {
      string str = text.ToString();
      str = Regex.Replace(str, @"(<br>|<br />)", "\r\n", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"</p>", "</p>\r\n", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"</div>", "</div>\r\n", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&nbsp;|&#160;", " ", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&copy;|&#169;", "©", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&reg;|&#174;", "®", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&trade;|&#8482;", "™", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&lt;|&#60;", "<", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&gt;|&#62;", ">", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&laquo;|&#171;", "«", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&raquo;|&#187;", "»", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"&amp;|&#38;", "&", RegexOptions.IgnoreCase);
      worker.ReportProgress(percent + 2);
      str = Regex.Replace(str, @"\t", String.Empty, RegexOptions.IgnoreCase);                                 // odstranění tabulátorů
      worker.ReportProgress(percent + 1);
      str = Regex.Replace(str, @"<script[\d\D]*?>[\d\D]*?</script>", String.Empty, RegexOptions.IgnoreCase);  // odstranění skriptů
      worker.ReportProgress(percent + 4);
      str = Regex.Replace(str, @"(/\*[\w\W]*\*/)", String.Empty, RegexOptions.IgnoreCase);                    // odstranění komentářů
      worker.ReportProgress(percent + 1);
      puvodniText.Append(str);
      text.Clear();
      text.Append(removeHTMLandSpaces(str));
      worker.ReportProgress(percent + 20);
    }

    /// <summary>
    /// odstranění tagů ze získaného textu
    /// </summary>
    /// <param name="str"></param>
    /// <returns></returns>
    private string removeHTMLandSpaces(string str)
    {
      str = Regex.Replace(str, @"<[a-z|/|!--]+(.|\n)*?>", " ", RegexOptions.IgnoreCase);                   // odstranění HTML tagů a HTML komentářů
      str = Regex.Replace(str, @" {2,}", " ", RegexOptions.IgnoreCase);                                    // odstranění zbytečných mezer v textu
      str = Regex.Replace(str, @" *\r?\n( )*", "\r\n", RegexOptions.IgnoreCase);                           // odstranění mezer na začátku nebo konci řádků
      str = Regex.Replace(str, @"(\r){2,}", "\r", RegexOptions.IgnoreCase);                                // odstranění zdvojených znaků \r
      str = Regex.Replace(str, @"(\n){2,}", "\n", RegexOptions.IgnoreCase);                                // odstranění zdvojených unaků \n
      str = Regex.Replace(str, @"\r( )+", String.Empty, RegexOptions.IgnoreCase);                          // odstranění samotných znaků \r
      str = Regex.Replace(str, @"(?<=(?:\r?\n){2}|\A)(?:\r?\n)+", String.Empty, RegexOptions.IgnoreCase);  // odstranění zdvojených prázdných řádků
      return str;
    }

    /// <summary>
    /// spočítání četnosti všech slov
    /// </summary>
    private void countOccurrence(BackgroundWorker worker)
    {
      Match m = Regex.Match(text.ToString(), @"[\w]{" + cfg_cetnostDelka + ",}", RegexOptions.IgnoreCase);
      while (m.Success)
      {
        if (cetnost.ContainsKey(m.Value.ToLower()))
        {
          cetnost[m.Value.ToLower()]++;
        }
        else
        {
          cetnost.Add(m.Value.ToLower(), 1);
        }
        m = m.NextMatch();
      }
      worker.ReportProgress(percent + 10);
    }

    /// <summary>
    /// spočítání četnosti slov nebo výrazů zadaných uživatelem
    /// </summary>
    private void countOccurrenceUser(BackgroundWorker worker, string word)
    {
      int found;
      int index = 0;
      while (true)
      {
        found = text.ToString().ToLower().IndexOf(word, index);
        if (found == -1)
        {
          break;
        }
        cetnostVlastni[word]++;
        index = found + 1;
      }
      worker.ReportProgress(percent + 10);
    }

    /// <summary>
    /// zobrazení četnosti slov
    /// </summary>
    private void showCetnost()
    {
      try
      {
        OccurrenceWindow oknoCetnost = new OccurrenceWindow(this);
        oknoCetnost.ShowDialog();
      }
      catch (Exception ex)
      {
        MessageBox.Show("Knihovna \'ZedGraph.dll\' chybí nebo je poškozená!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      }
    }

    /// <summary>
    /// získání požadovaných informací dle zadaného výrazu
    /// </summary>
    private void getInformation()
    {
      string vystup = "";
      string match = "";
      string vyraz = textBoxVyraz.Text.Replace("\r\n", " ");
      vyraz = Regex.Replace(vyraz, @"\^", "\\^");
      vyraz = Regex.Replace(vyraz, @"\$", "\\$");
      vyraz = Regex.Replace(vyraz, @"\*", "\\*");
      vyraz = Regex.Replace(vyraz, @"\+", "\\+");
      vyraz = Regex.Replace(vyraz, @"\?", "\\?");
      vyraz = Regex.Replace(vyraz, @"\.", "\\.");
      vyraz = Regex.Replace(vyraz, @"\[", "\\[");
      vyraz = Regex.Replace(vyraz, @"\]", "\\]");
      vyraz = Regex.Replace(vyraz, @"\{", "\\{");
      vyraz = Regex.Replace(vyraz, @"\}", "\\}");
      vyraz = Regex.Replace(vyraz, @" *\|( )*", "|");
      vyraz = Regex.Replace(vyraz, @" *&( )*", "(.|\n)*?");
      vyraz = Regex.Replace(vyraz, @" *_( )*", "(\\w)*");
      vyraz = Regex.Replace(vyraz, @"( )*\(( )*", "(");
      vyraz = Regex.Replace(vyraz, @"( )*\)( )*", ")");
      vyraz = Regex.Replace(vyraz, @" {2,}", " ");
      match += (checkBoxP.Checked == true) ? "(<p(.|\n)*?</p>)|" : String.Empty;
      match += (checkBoxDiv.Checked == true) ? "(<div(.|\n)*?</div>)|" : String.Empty;
      match += (checkBoxSpan.Checked == true) ? "(<span(.|\n)*?</span>)|" : String.Empty;
      match += (checkBoxH.Checked == true) ? "(<h([1-6]){1}(.|\n)*?</h([1-6]){1}>)|" : String.Empty;
      match += (checkBoxForm.Checked == true) ? "(<form(.|\n)*?</form>)|" : String.Empty;
      match += (checkBoxTable.Checked == true) ? "(<table(.|\n)*?</table>)|" : String.Empty;
      match += (checkBoxA.Checked == true) ? "(<a(.|\n)*?</a>)|" : String.Empty;
      match += (checkBoxOl.Checked == true) ? "(<ol(.|\n)*?</ol>)|" : String.Empty;
      match += (checkBoxUl.Checked == true) ? "(<ul(.|\n)*?</ul>)" : String.Empty;
      try
      {
        if (match != "")
        {
          match = match.TrimEnd('|');
          Match m = Regex.Match(puvodniText.ToString(), @match);
          while (m.Success)
          {
            if (Regex.IsMatch(removeHTMLandSpaces(m.ToString()), @vyraz, (cfg_vyrazCS == 0) ? RegexOptions.IgnoreCase : RegexOptions.None))
            {
              vystup += m.ToString() + "\r\n\r\n";
            }
            m = m.NextMatch();
          }
          if (vystup.Length > 0)
          {
            richTextBoxVystup.Text = removeHTMLandSpaces(vystup).Trim();
          }
          else
          {
            richTextBoxVystup.Text = "";
            MessageBox.Show("Nic nenalezeno. Zkuste upravit zadaný výraz.", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Information);
          }
        }
        else
        {
          MessageBox.Show("Zvolte alespoň jeden HTML prvek pro získání informací!", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
      }
      catch (Exception ex)
      {
        showError(ex);
      }
    }

    /// <summary>
    /// umožnění výpisu získaného textu
    /// </summary>
    /// <param name="worker"></param>
    private void showResult(BackgroundWorker worker)
    {
      result = 1;
      worker.ReportProgress(100);
    }
    #endregion


    #region hlavni
    // ----------------------------------------------------------------------------------------- //
    //  HLAVNÍ ČÁST PROGRAMU
    // ----------------------------------------------------------------------------------------- //

    /// <summary>
    /// provádění úkolů v pracovním vlákně
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void bw_DoWork(object sender, DoWorkEventArgs e)
    {
      BackgroundWorker worker = sender as BackgroundWorker;
      loadPage(worker, e);
      if (cfg_title == 1)
      {
        getTitle(worker);
      }
      getBody(worker);
      removeTags(worker);
      if ((cfg_cetnost == 1) && (cfg_cetnostRBtn == 0))
      {
        countOccurrence(worker);
      }
      else if ((cfg_cetnost == 1) && (cfg_cetnostRBtn == 1))
      {
        foreach (String item in cetnostVlastni.Keys.ToList())
        {
          countOccurrenceUser(worker, item);
        }
      }
      showResult(worker);
      if (text.ToString().Trim() == "")
      {
        MessageBox.Show("Zadaný vstup neobsahuje žádný text! Zkuste zadat jiný vstup.", msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Information);
      }
    }

    /// <summary>
    /// úprava stavu úkolu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void bw_ProgressChanged(object sender, ProgressChangedEventArgs e)
    {
      progress.AktualizaceStavu(e.ProgressPercentage);
      if (result == 1)
      {
        textBoxTitulek.Text = title.Trim();
        richTextBoxVystup.Text = text.ToString().Trim();
        if (richTextBoxVystup.Text.Length > 0)
        {
          setComponents(true);
        }
      }
    }

    /// <summary>
    /// přerušení a ukončení úkolu, výpis chyb
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void bw_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
    {
      if (e.Cancelled == true)
      {
        progress.Close();
      }
      else if (!(e.Error == null))
      {
        MessageBox.Show(e.Error.Message, msgtitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
      }
      else
      {
        progress.Close();
      }
    }
    #endregion
  }
}
