﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ZedGraph;

namespace Diplomová_práce
{
  public partial class OccurrenceWindow : Form
  {
    private MainWindow mainw;

    public OccurrenceWindow(MainWindow mainw)
    {
      InitializeComponent();
      this.mainw = mainw;
      setGraph();
    }

    private void OccurrenceWindow_Load(object sender, EventArgs e)
    {
    }

    /// <summary>
    /// nastavení parametrů grafu a jeho vykreslení
    /// </summary>
    private void setGraph()
    {
      List<string> vyrazy = new List<string>();
      List<double> hodnoty = new List<double>();
      string nadpis;
      foreach (KeyValuePair<string, int> item in ((mainw.cfg_cetnostRBtn == 0) ? mainw.cetnost : mainw.cetnostVlastni).OrderBy(key => key.Value))
      {
        vyrazy.Add(item.Key + " (" + item.Value + ")");
        hodnoty.Add(item.Value);
      }
      if ((mainw.cfg_cetnostRBtn == 0) && (vyrazy.Count > mainw.cfg_cetnostLimit))
      {
        vyrazy.RemoveRange(0, vyrazy.Count - mainw.cfg_cetnostLimit);
        hodnoty.RemoveRange(0, hodnoty.Count - mainw.cfg_cetnostLimit);
      }
      if (vyrazy.Count == 1)
      {
        nadpis = " nejčetnější " + ((mainw.cfg_cetnostRBtn == 0) ? "slovo" : "výraz");
      }
      else if ((vyrazy.Count >= 2) && (vyrazy.Count <= 4))
      {
        nadpis = " nejčetnější " + ((mainw.cfg_cetnostRBtn == 0) ? "slova" : "výrazy");
      }
      else
      {
        nadpis = " nejčetnějších " + ((mainw.cfg_cetnostRBtn == 0) ? "slov" : "výrazů");
      }
      zedGraphControlCetnost.GraphPane.CurveList.Clear();
      zedGraphControlCetnost.GraphPane.Title.Text = vyrazy.Count + nadpis;
      zedGraphControlCetnost.GraphPane.AddBar(null, hodnoty.ToArray(), null, mainw.cfg_barvaGrafu);
      zedGraphControlCetnost.GraphPane.XAxis.Title.Text = "Počet výskytů";
      zedGraphControlCetnost.GraphPane.YAxis.Title.Text = "";
      zedGraphControlCetnost.GraphPane.YAxis.Scale.TextLabels = vyrazy.ToArray();
      zedGraphControlCetnost.GraphPane.YAxis.Type = AxisType.Text;
      zedGraphControlCetnost.GraphPane.BarSettings.Type = ZedGraph.BarType.Stack;
      zedGraphControlCetnost.GraphPane.BarSettings.Base = BarBase.Y;
      zedGraphControlCetnost.AxisChange();
      zedGraphControlCetnost.Invalidate();
    }
  }
}
